package ru.dbotthepony.mc.otm.config

import net.minecraftforge.fml.config.ModConfig

object ClientConfig : AbstractConfig("client", ModConfig.Type.CLIENT) {

	var JUMP_BOOST_LOOK_ANGLE: Double by builder
		.comment("If looking below this angle (actually, looking 'above' as you see in game, but not as you expect it, check with debug screen), Crouch + Jump will trigger jump boost android ability")
		.defineInRange("JUMP_BOOST_LOOK_ANGLE", 30.0, -180.0, 180.0)

	object Tooltip {
		init {
			builder.push("Tooltip")
		}

		var ALWAYS_DISPLAY_MATTER_VALUE: Boolean by builder
			.comment("Always display matter value in tooltips without requiring holding Shift key")
			.define("ALWAYS_DISPLAY_MATTER_VALUE", false)

		var DISPLAY_TAGS: Boolean by builder
			.comment("Display block/item tags in advanced item tooltips")
			.define("DISPLAY_TAGS", false)

		init {
			builder.pop()
		}
	}

	object GUI {
		init {
			builder.comment("Inventory/GUI options").push("Gui")
		}

		var EXOPACK_INVENTORY_ROWS: Int by builder
			.comment("Amount of inventory rows to show when wearing Exosuit")
			.defineInRange("EXOPACK_INVENTORY_ROWS", 3, 3, 6)

		var EXOPACK_FREE_SCROLL: Boolean by builder
			.comment("Allow to scroll Exopack inventory in non OTM inventories when hovering just over inventory slots, not only scrollbar")
			.define("EXOPACK_FREE_SCROLL", true)

		var REDSTONE_CONTROLS_ITEM_ICONS: Boolean by builder
			.comment("Display redstone control button using items instead of custom sprites")
			.comment("For those who want it.")
			.define("REDSTONE_CONTROLS_ITEM_ICONS", false)

		init {
			builder.pop()
		}
	}

	object HUD {
		init {
			builder.push("HUD")
		}

		var ANDROID_HEALTH_BAR: Boolean by builder
			.comment("Replace hearts with health bar on HUD when you are an android")
			.define("ANDROID_HEALTH_BAR", true)

		var BAR_TEXT_SCALE: Double by builder
			.defineInRange("BAR_TEXT_SCALE", 0.5, 0.5, 1.0)

		init {
			builder.pop()
		}
	}

	init {
		Tooltip
		GUI
		HUD
	}
}
